; txt2ascii.asm
; Autorius: Andrius Paurys
; Data: 2007-10-22

.model small
.stack 10h                     ; 16 baitu stekas
.data

    help1   DB "Andrius Paurys MIF VU PS 5gr",10,13,"$"
    help2   DB "1 programa 6 uzdavinys",10,13,"$"
    help3   DB "Programa ishveda nuskaitytos eilutes simboliu ASCII kodus deshimtainej sistemoj",10,13,"$"
    msg     DB "Iveskite teksto eilute: ",10,13,"$"
    text    DB 0ffh,?, 255 dup(?)
    nl      DB 10,13,"$"


.code
    mov     dx, @data           ; Ishsitraukiam duomenu segmento pradzhia
    mov     ds, dx

    jmp     helpas

start:

    mov     ah, 09h             ; Isvedam zhinute 'msg'
    mov     dx, offset msg
    int     21h

    mov     ah, 0ah             ; Nuskaitom ish ekrano eilute iki 255 simb.
    mov     dx, offset text
    int     21h

    mov     ah, 09h             ; Isvedam naujos eilutes simboli
    mov     dx, offset nl
    int     21h

    xor     cx, cx              ; Uzhnulinam cx...
    mov     cl, text[1]         ; ... ir padedam ten ivestos eilutes ilgi

    mov     bx, 02h             ; I bx pasidedam 2, nes reikes pradeti skaityti nuo 3
                                ; buferio baito (1b max ilgis, 2b realus ilgis)

ciklas:                         ; Organizuojam cikla simboliu ishvedimui:
                                ; cl mazheja ir rodo kiek simboliu dar liko nagrinet
                                ; bx dideja ir rodo kelinta simboli nagrinejam +2

    mov     al, text[bx]        ; I al ish eiles dedam po viena simboli
    inc     bx

    mov     dl, 10
    ciklas_skaidom:             ; ish ax paima skaiciu, ji ishskaido skaitmenimis
        mov     ah, 0
        div     dl              ; dalinam ax is 10 
        push    ax              ; dalybos liekana pasidedam i steka
        cmp     al, 0           ; pazhiurim ar sveikoji dalis daugiau uzh 0
        jne     ciklas_skaidom  ; jei dalyb. sveikoji dalis nelygi 0 skaidom toliau


    mov     ah, 02h
    ciklas_isvedam:             ; ish stacko ishveda skaitmenis
        pop     dx              ; pasiimam ish steko
        mov     dl, dh          ; reik sukeist, nes high baite stovi liekana, o interrupt
        add     dl, 30h         ;                             ishveda ish low baito.
        int     21h
        cmp     sp, 10h         ; tikrinam ar stekas dar netuscias
        jne     ciklas_isvedam  ; ir jei netuscias grizhtam

    mov     dl, ' '             ; ishvedam tarpeli skaichiu atskyrimui
    int     21h

    loop    ciklas

    jmp     baik


helpas:
    mov     bx, 81h             ; programos paleidimo parametrai rasomi segmente es
                                ;                    pradedant 129 (arba 81h) baitu    
    helpas_ieskok:
        mov     ax, es:[bx]     ; i ax isirasom 2 baitus, i kuriuos rodo es:bx
        cmp     al, 0dh         ; tikrinam, ar tai ne pabaigos simbolis
        je      start           ; jei taip, vadinasi neradau "/?" ir tesiu norm. darba
        cmp     ax, 3f2fh       ; o gal nuskaityta "/?" - 3F = '?'; 2F = '/'
        je      helpas_isvesk   ; radau "/?", vadinasi turiu isvesti pagalba
        inc     bx              ; neradau "/?" siuose baituose, paslenku rodykle ir
                                ;                tikrinu toliau esancius parametrus
        jmp     helpas_ieskok   ; tesiam paieshka

    helpas_isvesk:
        mov     ah, 09h         ; isvedam zhinute
        mov     dx, offset help1
        int     21h
        mov     dx, offset help2
        int     21h
        mov     dx, offset help3
        int     21h 
        jmp     baik


baik:
    mov     ah, 4ch             ; Programa grazhina darba operacinei sistemai
    int     21h
